(*--------------------------------------------------------------------------*)
(*                  Copyright (c) Donald Syme 1992                          *)
(*                  All rights reserved                                     *)
(*                                                                          *)
(* Donald Syme, hereafter referred to as `the Author', retains the copyright*)
(* and all other legal rights to the Software contained in this file,       *)
(* hereafter referred to as `the Software'.                                 *)
(*                                                                          *)
(* The Software is made available free of charge on an `as is' basis. No    *)
(* guarantee, either express or implied, of maintenance, reliability,       *)
(* merchantability or suitability for any purpose is made by the Author.    *)
(*                                                                          *)
(* The user is granted the right to make personal or internal use of the    *)
(* Software provided that both:                                             *)
(* 1. The Software is not used for commercial gain.                         *)
(* 2. The user shall not hold the Author liable for any consequences        *)
(*    arising from use of the Software.                                     *)
(*                                                                          *)
(* The user is granted the right to further distribute the Software         *)
(* provided that both:                                                      *)
(* 1. The Software and this statement of rights are not modified.           *)
(* 2. The Software does not form part or the whole of a system distributed  *)
(*    for commercial gain.                                                  *)
(*                                                                          *)
(* The user is granted the right to modify the Software for personal or     *)
(* internal use provided that all of the following conditions are observed: *)
(* 1. The user does not distribute the modified software.                   *)
(* 2. The modified software is not used for commercial gain.                *)
(* 3. The Author retains all rights to the modified software.               *)
(*                                                                          *)
(* Anyone seeking a licence to use this software for commercial purposes is *)
(* invited to contact the Author.                                           *)
(*--------------------------------------------------------------------------*)



   

signature RegularInterfaceMaps_sig = sig
   type interface_map
   type map; (* = {
      add : ((kind * string) * (look * string) list) list -> unit,
      set_default_look : look -> unit,
      remove : ((kind * string) * (look * string) list) -> unit,
      remove_default : (kind * look) -> unit,
      external_to_internal : (look * string) list -> string,
      internal_to_external : (kind * string) -> (look * string) list,
      clear : unit -> unit
   }; *)
   val new : unit -> map;
   val restrict : map -> interface_map;
end;

signature SumInterfaceMaps_sig = sig
   type interface_map
   type map; (* =  {
      add : (string * interface_map) -> unit,
      remove : string -> unit,
      external_to_internal : (look * string) list -> string,
      internal_to_external : (kind * string) -> (look * string) list
   } *)
   val new : unit -> map;
   val restrict : map -> interface_map;
end;

signature InterfaceMaps_sig =
sig
        eqtype kind sharing type kind = string;
        eqtype look sharing type look = string;
        exception INTERFACE_MAP;
        type interface_map; (* = {
           external_to_internal : (look * string) list -> string,
           internal_to_external : (kind * string) -> (look * string) list
        }; *)

        structure Regular : RegularInterfaceMaps_sig

        structure Sum : SumInterfaceMaps_sig

end;

